# pict-rs 0.5.15

pict-rs is a simple image hosting microservice, designed to handle storing and retrieving images,
animations, and videos, as well as providing basic image processing functionality.

## Overview

pict-rs 0.5.15 includes a bugfix for cleaning proxied media, updated dependencies, and a new option
to log requests.

### Fixes

- [Proxied Media Cleanup](#proxied-media-cleanup)


### Additions

- [Request Logging](#request-logging)


## Upgrade Notes

There are no significant changes from 0.5.14. Upgrading should be a simple as pulling a new version
of pict-rs.


## Descriptions

### Proxied Media Cleanup

At some point, the cleanup logic for proxied media got flipped around to try removing the internal
alias before removing the proxy record. This works fine with a sled backend, but not with a
postgres backend, and postgres would complain about invalidating a foreign key relationship.
pict-rs 0.5.15 fixes this by ensuring that the related proxy record is cleaned first.


### Request Logging

A new configuration option has been added to pict-rs as an option to get more information about
what pict-rs is doing. By default, pict-rs only logs what it considers to be errors, but when
`log_requests` is enabled, it will also log information about successful requests. This can help
with debugging without enabling full debug logs or resorting to logging spans.

It can be configured via toml
```toml
[tracing.logging]
log_requests = true
```

via environment variables
```bash
PICTRS__TRACING__LOGGING__LOG_REQUESTS=true
```

or via the commandline
```bash
pict-rs --log-requests run
```
