# pict-rs 0.5.16

pict-rs is a simple image hosting microservice, designed to handle storing and retrieving images,
animations, and videos, as well as providing basic image processing functionality.

## Overview

pict-rs 0.5.16 includes a couple bugfixes for parsing query paramters, better handling of proxied
media, clearer postgres errors, and updated dependencies.

### Fixes

- [Query Fixes](#query-fixes)
- [Better Concurrent Proxies](#better-concurrent-proxies)


### Changes

- [Improved Postgres Errors](#improved-postgres-errors)


## Upgrade Notes

There are no significant changes from 0.5.15. Upgrading should be a simple as pulling a new version
of pict-rs.


## Descriptions

### Query Fixes

A couple boolean query parameters were not getting parsed properly, this impacted ?backgrounded for
image downloads and ?force for pruning media. pict-rs 0.5.16 resolves this.


### Better Concurrent Proxies

When the same proxy endpoint was accessed more than once concurrently, only one request would end up
succeeding. Now pict-rs better handles when multiple concurrent requests are made.


### Improved Postgres Errors

In some postgres errors, it is difficult to tell whether an error originated from within the
postgres client or the postgres server. pict-rs 0.5.16 now includes extra context when displaying
postgres errors to help discern this.
