use std::borrow::Cow;

use crate::{
    details::DetailsInner,
    path_gen::{PathItem, PathNode},
};

use super::FjallError;

impl<'a> PathItem<'a> for DetailsInner {
    type Error = FjallError;

    fn to_bytes(&self) -> Cow<'_, [u8]> {
        Cow::Owned(serde_json::to_vec(self).expect("valid json"))
    }

    fn parse(bytes: Cow<'a, [u8]>) -> Result<Self, Self::Error>
    where
        Self: Sized + 'a,
    {
        serde_json::from_slice(&bytes).map_err(FjallError::Details)
    }
}

impl<'a> PathNode<'a> for DetailsInner {
    const NAME: &'static [u8] = b"details";
}
