use std::borrow::Cow;

use crate::{
    path_gen::{PathItem, PathNode},
    repo::Hash,
};

use super::FjallError;

impl<'a> PathItem<'a> for Hash {
    type Error = FjallError;

    fn to_bytes(&self) -> Cow<'_, [u8]> {
        Cow::Owned(self.to_bytes())
    }

    fn parse(bytes: Cow<'a, [u8]>) -> Result<Self, Self::Error>
    where
        Self: Sized + 'a,
    {
        Self::from_bytes(&bytes).ok_or(FjallError::Hash)
    }
}

impl<'a> PathNode<'a> for Hash {
    const NAME: &'static [u8] = b"hash";
}
